# -*- coding: utf-8 -*-

import logging

import requests
from django.conf import settings
from django.db import transaction
from django_six import CompatibilityBaseCommand, close_old_connections

from utils.redis.connect import r
from utils.redis.rkeys import MINI_PROGRAM_GIS_LIST


logger = logging.getLogger('console')


class Command(CompatibilityBaseCommand):
    def handle(self, *args, **options):

        logger.info('Gis is dealing')

        while True:
            # r.rpushjson('TEMPLET_CMD_KEY', {
            #     'lat': .0,
            #     'lon': .0,
            #     'ymd': 0,
            #     'ym': 0,
            # })
            k, v = r.blpopjson(MINI_PROGRAM_GIS_LIST, 60)
            if v:

                close_old_connections()

                logger.info(v)

                with transaction.atomic():
                    try:
                        gisinfo = requests.get(settings.GIS_2_ADMINISTRATIVE_DIVISION.format(v.get('lat', 0), v.get('lon', 0))).json()
                    except Exception as e:
                        logger.info(e.message)
                    if gisinfo.get('error') != 0:
                        continue
                    ymd = v.get('ymd', 0)
                    ym = v.get('ym', 0)
                    zh1 = gisinfo.get('data', {}).get('zh1', '')

                close_old_connections()
